//ada_if.c

/**
 * @file  ada_if.c
 * @brief I[fBIC^tF[X
 *
 * @version: $Id $
 *
 * {\tgEFA̒쌠͍쐬ł()kldqL̂ƂA
 * ()kldq́Aȉ (1)`(3) ̏𖞂ꍇɌA
 * {\tgEFAi{\tgEFAς̂܂ށBȉj
 * gpEEρEĔzziȉApƌĂԁj邱Ƃ𖳏ŋB
 *
 * (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́AL̒
 *	   \A̗pÂ܂܂̌`Ń\[XR[hɊ܂܂
 *	   邱ƁB
 * (2) {\tgEFÄꕔ܂͑SĂ𖳒fœ]ڂ邱Ƃ֎~
 *	   ƂBGȂǂ֏ЉE^̏ꍇ()kldqɘA肢܂B
 * (3) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹Q
 *	   A()kldq͈؂̐ӔC𕉂Ȃ̂ƂB
 *
 * Copych1 (C) Hokuto denshi Co,Ltd. 2021
 */
 
#include <machine.h>
#include <stdlib.h>
#include "iodefine.h"
#include "ada_if.h"
#include "board.h"
#include "Config_CMT1.h"
#include "Config_ICU.h"

#pragma section extra_ram
PCM_float g_pcm0[INPUT_BUFFER_SIZE];	//ő512kB
#pragma section

#pragma section buf_ram
PCM_float g_pcm1[OUTPUT_BUFFER_SIZE];	//ő448kB
#pragma section


//֐vg^Cv

void ada_if_init( void );
int ada_if_start( void );
int ada_if_input_index(int n);
int ada_if_output_index(int n);
int ada_if_input_index_diff(int n, int m);
int ada_if_output_index_diff(int n, int m);


//̓obt@, o̓obt@zCfbNX
volatile int g_input_index = 0;
volatile int g_output_index = 0;

PCM_float g_zero_data;

//XCb`̓ǂݎ
unsigned long g_sw_state = 0;			//SW2

//A/DϊtOA/Dϊ
unsigned short g_ad_flag = 0;
unsigned short g_ad_val[3] = {2048, 2048, 2048};			//AN000-002, l͒_ɐݒ

//LED
unsigned long g_led_pattern = 0;		//D7
unsigned long g_led_pattern_index = 0;

//荞݊֐`

#pragma interrupt (Intr_SSIE0_SSITX0(vect=46))
void Intr_SSIE0_SSITX0(void);

#pragma interrupt (Intr_SSIE0_SSIRX0(vect=47))
void Intr_SSIE0_SSIRX0(void);

void Intr_SSIE0_SSIF0(void);

//֐`

void ada_if_init(void)
{
	//֐
	
	//FȂ
	
	//߂lFȂ

#if (USE_CH == 1)
#elif (USE_CH == 2)
#else
#error "USE_CH -> 1 or 2.
#endif

#if (FIFO_BUFFER_SIZE < 1)
#error "FIFO_BUFFER_SIZE < 1."
#elif (FIFO_BUFFER_SIZE > 15)
#error "FIFO_BUFFER_SIZE > 15."
#endif
	
	int i;
	volatile int x;

	/* ϐ */
	
	g_zero_data.ch0 = 0.0f;
	
#if (USE_CH == 2)
	g_zero_data.ch1 = 0.0f;
#endif
	

	//obt@
	for(i=0; i<INPUT_BUFFER_SIZE; i++)
	{
		g_pcm0[i] = g_zero_data;	//̓obt@
	}
	
	for(i=0; i<OUTPUT_BUFFER_SIZE; i++)
	{
		g_pcm1[i] = g_zero_data;	//o̓obt@
	}

	//ADA-IF{[hZbg
#if (PIN_NO == 176)
	
	//RESET=P11
	PORT1.PODR.BIT.B1 = 0;
	PORT1.PDR.BIT.B1 = 1;
	
#elif (PIN_NO == 144)

	//RESET=P12
	PORT1.PODR.BIT.B2 = 0;
	PORT1.PDR.BIT.B2 = 1;
#endif
	
	/* W[veNg */
	SYSTEM.PRCR.WORD = 0xA502U;
	SYSTEM.MSTPCRD.BIT.MSTPD15 = 0;		//SSIE0W[Xgbv̉
	SYSTEM.PRCR.WORD = 0xA500U;

	/* [qݒ */
	
	//MPCWX^ی
    MPC.PWPR.BIT.B0WI = 0U;
    MPC.PWPR.BIT.PFSWE = 1U;
	
	//PFSݒ
	MPC.P17PFS.BIT.PSEL = 0x17;		//SSITXD0
	MPC.P20PFS.BIT.PSEL = 0x17;		//SSIRXD0
	MPC.P21PFS.BIT.PSEL = 0x17;		//SSILRCK0
	MPC.P22PFS.BIT.PSEL = 0x17;		//AUDIO_CLK
	MPC.P23PFS.BIT.PSEL = 0x17;		//SSIBCK0
	
	//MPCWX^ی
    MPC.PWPR.BIT.PFSWE = 0U;
    MPC.PWPR.BIT.B0WI = 1U;
	
	//PMRݒ
	PORT1.PMR.BIT.B7 = 1;
	PORT2.PMR.BIT.B0 = 1;
	PORT2.PMR.BIT.B1 = 1;
	PORT2.PMR.BIT.B2 = 1;
	PORT2.PMR.BIT.B3 = 1;
	
	//USB HostVBUSȂi{[hD1sɓ_̂}~j
	PORT2.PODR.BIT.B4 = 0;
	PORT2.PDR.BIT.B4 = 1;
	
	/* 荞ݐݒ */
	
	//M荞
	ICU.IER[0x05].BIT.IEN6 = 0;	//vect46, SSIE0.SSITXI0
	ICU.IER[0x05].BIT.IEN7 = 0;	//vect47, SSIE0.SSIRXI0
	ICU.IR[46].BIT.IR = 0;
	ICU.IR[47].BIT.IR = 0;
	ICU.IPR[46].BIT.IPR = 15;	//荞ݗDxő
	ICU.IPR[47].BIT.IPR = 15;	//荞ݗDxő
	ICU.IER[0x05].BIT.IEN6 = 1;
	ICU.IER[0x05].BIT.IEN7 = 1;

	
	//Xe[^X荞݁iO[vBL1, xN^111Ɋ蓖āj
	ICU.GENBL1.BIT.EN17 = 1;
	R_BSP_InterruptWrite(BSP_INT_SRC_BL1_SSIE0_SSIF0,(bsp_int_cb_t)Intr_SSIE0_SSIF0);	//R[obN֐
	ICU.IER[0xD].BIT.IEN7 = 1;	//vect111
	ICU.IR[111].BIT.IR = 0;
	ICU.IPR[111].BIT.IPR = 12;	//荞ݗDx12
	ICU.IER[0xD].BIT.IEN7 = 1;

#if (USE_ADC_PORT == 1) || (USE_LED == 1)
	//ADCLEDgꍇCMT1X^[g
	R_Config_CMT1_Start();			//CMT1i50msj
#endif

#if (USE_LED == 1)
	//LEDgꍇ
	PORT0.PODR.BIT.B5 = 0;
	PORT0.PDR.BIT.B5 = 1;
#endif

#if (SW_STATE_NUM != 0)
	//SWgꍇ
	R_Config_ICU_IRQ15_Start();
#endif


	for(x=0; x<10000; x++) __nop();	//wait
	
	//ADA-IF{[hZbg
#if (PIN_NO == 176)
	
	//RESET=P11
	PORT1.PODR.BIT.B1 = 1;
	
#elif (PIN_NO == 144)

	//RESET=P12
	PORT1.PODR.BIT.B2 = 1;
	
#endif

	for(x=0; x<10000; x++) __nop();	//MCLKU wait
	
	/* SSIE0ݒ */
	SSIE0.SSIFCR.BIT.SSIRST = 1;	//SSIẼZbg
	SSIE0.SSIFCR.BIT.SSIRST = 0;	//Zbg
	while(SSIE0.SSIFCR.BIT.SSIRST != 0)	__nop();	//Zbg̊mF
	
	SSIE0.SSICR.BIT.MST = 1;		//}X^[[h
	SSIE0.SSIFCR.BIT.AUCKE = 0;		//MCK~߂
	
	SSIE0.SSICR.BIT.CKDV = 0x2;		//4(12.288MHz/4=3.072MHz, 64bitx48kHz)
	SSIE0.SSICR.BIT.BCKP = 0;		//SSIBCKriseœ̓TvOAfallŏo
	
	SSIE0.SSIFCR.BIT.AUCKE = 1;		//MCK
	
	//SSIE0荞ݐݒ
	SSIE0.SSISCR.BIT.RDFS = FIFO_BUFFER_SIZE*2;		//Mf[^FIFO_BUFFER_SIZE*2/32܂RDFtO𗧂Ăi16->48kHz 8sample->166.64us)
	SSIE0.SSISCR.BIT.TDES = FIFO_BUFFER_SIZE*2;		//Mf[^FIFO_BUFFER_SIZE*2/32̋󂫂ɂȂTDFtO𗧂Ă
	SSIE0.SSICR.BIT.IIEN = 0;		//ACh荞݋֎~
	SSIE0.SSICR.BIT.ROIEN = 1;		//MI[ot[荞݋
	SSIE0.SSICR.BIT.RUIEN = 1;		//MA_[t[荞݋
	SSIE0.SSICR.BIT.TOIEN = 1;		//MI[o[t[荞݋
	SSIE0.SSICR.BIT.TUIEN = 1;		//MA_[t[荞݋
	
	//tH[}bgI
	SSIE0.SSICR.BIT.DEL = 0;		//SSILRCK̃GbW̃f[^o:1bitNbNԒx
	SSIE0.SSICR.BIT.PDTA = 0;		//f[^l
	SSIE0.SSICR.BIT.SDTA = 0;		//I2StH[}bgif[^ApfBȌj
	SSIE0.SSICR.BIT.SPDP = 0;		//pfBOf[^0
	SSIE0.SSICR.BIT.LRCKP = 0;		//LRCLK=L->Lch
		
	SSIE0.SSICR.BIT.SWL = 0x3;		//VXe[h32bit
	SSIE0.SSICR.BIT.DWL = 0x5;		//f[^[h24bit
	SSIE0.SSICR.BIT.FRM = 0x0;		//LR 2ch1t[

	SSIE0.SSIFCR.BIT.BSW = 0;		//SSIFTDRWX^̃oCgXbvȂirbOGfBAC[Wj
	
	SSIE0.SSIOFR.BIT.OMOD = 0;		//I2StH[}bg
	
	//o͐ݒ
	SSIE0.SSIOFR.BIT.LRCONT = 0;	//AChLRCK~߂
	SSIE0.SSIOFR.BIT.BCKASTP = 0;	//AChBCK~߂
	SSIE0.SSICR.BIT.MUEN = 0;		//~[g
	
	//M
	SSIE0.SSIFCR.BIT.TFRST = 1;		//MFIFOZbg
	SSIE0.SSIFCR.BIT.TFRST = 0;		//Zbg
	while(SSIE0.SSIFCR.BIT.TFRST != 0)	__nop();	//Zbg̊mF
	for(i=0; i< FIFO_BUFFER_SIZE*2; i++)
	{
		SSIE0.SSIFTDR.LONG = 0x0000;	//MFIFOɏf[^i[, MJn㒼ɑMFIFO荞݂1
	}
	SSIE0.SSIFSR.BIT.TDE = 0;		//MFIFO荞݃tONA
	SSIE0.SSIFCR.BIT.TIE = 1;		//Mf[^GveB荞݋
	
	//M
	SSIE0.SSIFCR.BIT.RFRST = 1;		//MFIFOZbg
	SSIE0.SSIFCR.BIT.RFRST = 0;		//Zbg
	while(SSIE0.SSIFCR.BIT.RFRST != 0)	__nop();	//Zbg̊mF
	SSIE0.SSIFSR.BIT.RDF = 0;		//MFIFO荞݃tONA
	SSIE0.SSIFCR.BIT.RIE = 1;		//Mf[^t荞݋

}

int ada_if_start(void)
{
	//Jn֐
	
	//FȂ
	
	//߂lF
	//  0 : I
	//  1 : SSIN^CAEg
	
	volatile unsigned long x = 0;
	
	SSIE0.SSICR.LONG |= 0x0003;	//TEN,REN=1 M
	while(SSIE0.SSISR.BIT.IIRQ != 0)
	{
		__nop();
		x++;
		if(x > 1000000) return 1;
	}
	
	return 0;
}

int ada_if_input_index(int n)
{
	//g_inbuf_indexL͈͓ɃZbg֐
	
	//F
	//  int n CfbNXi̐INPUT_BUFFER_SIZE𒴂l󂯓j
	
	//߂lF
	//  0~INPUT_BUFFER_SIZE-1ɔ[܂鐔Ԃ
	
	if(n < 0)
	{
		n += INPUT_BUFFER_SIZE;
		
		if(n < 0)
		{
			n = n % INPUT_BUFFER_SIZE;
			return n;
		}
		else return n;
	}
	else if(n >= INPUT_BUFFER_SIZE)
	{
		n -= INPUT_BUFFER_SIZE;
		
		if(n >= INPUT_BUFFER_SIZE)
		{
			n = n % INPUT_BUFFER_SIZE;
			return n;
		}
		else return n;
	}
	else return n;
}

int ada_if_output_index(int n)
{
	//g_inbuf_indexL͈͓ɃZbg֐
	
	//F
	//  int n CfbNXi̐OUTPUT_BUFFER_SIZE𒴂l󂯓j
	
	//߂lF
	//  0~OUTPUT_BUFFER_SIZE-1ɔ[܂鐔Ԃ
	
	if(n < 0)
	{
		n += OUTPUT_BUFFER_SIZE;
		
		if(n < 0)
		{
			n = n % OUTPUT_BUFFER_SIZE;
			return n;
		}
		else return n;
	}
	else if(n >= OUTPUT_BUFFER_SIZE)
	{
		n -= OUTPUT_BUFFER_SIZE;
		
		if(n >= OUTPUT_BUFFER_SIZE)
		{
			n = n % OUTPUT_BUFFER_SIZE;
			return n;
		}
		else return n;
	}
	else return n;
}

int ada_if_input_index_diff(int n, int m)
{

	//g_inbuf_index̍vZ֐
	
	//F
	//  int n ƂȂCfbNXl
	//  int m ߂CfbNXl
	
	//߂lF
	//  nɑ΂msĂƂ͐̒lԂ܂
	//  mxĂꍇ͕̒lԂ܂
	//@INPUT_BUFFER_SIZE/2ΒlŏȒliOobt@ōl2̌oH̋߂j߂܂
	
	int tmp;
	
	if((n < 0) || (n >= INPUT_BUFFER_SIZE)) n = ada_if_input_index(n);
	if((m < 0) || (m >= INPUT_BUFFER_SIZE)) m = ada_if_input_index(m);
	
	tmp = m - n;
	
	if(abs(tmp) < (INPUT_BUFFER_SIZE/2)) return tmp;
	else if(tmp < 0) return tmp + INPUT_BUFFER_SIZE;
	else return tmp - INPUT_BUFFER_SIZE;
}

int ada_if_output_index_diff(int n, int m)
{

	//g_outpuf_index̍vZ֐
	
	//F
	//  int n ƂȂCfbNXl
	//  int m ߂CfbNXl
	
	//߂lF
	//  nɑ΂msĂƂ͐̒lԂ܂
	//  mxĂꍇ͕̒lԂ܂
	//@INPUT_BUFFER_SIZE/2ΒlŏȒliOobt@ōl2̌oH̋߂j߂܂
	
	int tmp;
	
	if((n < 0) || (n >= OUTPUT_BUFFER_SIZE)) n = ada_if_output_index(n);
	if((m < 0) || (m >= OUTPUT_BUFFER_SIZE)) m = ada_if_output_index(m);
	
	tmp = m - n;
	
	if(abs(tmp) < (OUTPUT_BUFFER_SIZE/2)) return tmp;
	else if(tmp < 0) return tmp + OUTPUT_BUFFER_SIZE;
	else return tmp - OUTPUT_BUFFER_SIZE;
}

//荞݊֐
void Intr_SSIE0_SSITX0(void)
{
	unsigned short i;
	float dataf;
	
	for(i=0; i<FIFO_BUFFER_SIZE; i++)
	{
		//ch0
		
		dataf = (g_pcm1[g_output_index].ch0 + 1.0f) / 2.0f * 2.147484e9f;	//32bitf[^ɕϊ
  		if (dataf > 2.147483e9f)
  		{
    		dataf = 2.147483e9f;
  		}
  		else if (dataf < 0.0f)
  		{
    		dataf = 0.0f;
  		}

		SSIE0.SSIFTDR.LONG = ((long)(dataf + 0.5f) - 214783648) & 0xffffff00;	//MFIFOɃf[^i[, M̂͏24bitf[^

		//ch1
		
#if (USE_CH == 1)
		SSIE0.SSIFTDR.LONG = 0x0000;	//ch1:0f[^
#else
		dataf = (g_pcm1[g_output_index].ch1 + 1.0f) / 2.0f * 2.147484e9f;	//32bitf[^ɕϊ
  		if (dataf > 2.147483e9f)
  		{
    		dataf = 2.147483e9f;
  		}
  		else if (dataf < 0.0f)
  		{
    		dataf = 0.0f;
  		}

		SSIE0.SSIFTDR.LONG = ((long)(dataf + 0.5f) - 214783648) & 0xffffff00;	//MFIFOɃf[^i[, M̂͏24bitf[^
#endif

#if (OUTPUT_BUFFER_AFTER_SEND == 0)
	//Mς݂̃f[^폜
		g_pcm1[g_output_index] = g_zero_data;
#endif

		g_output_index++;
		if(g_output_index >= OUTPUT_BUFFER_SIZE) g_output_index = 0;		
	}

	SSIE0.SSIFSR.BIT.TDE = 0;		//MFIFO荞݃tONA
}

void Intr_SSIE0_SSIRX0(void)
{
	
	extern unsigned long g_sampling_counter;
	unsigned short i;

#if (USE_CH == 1)
	volatile long dummy;
#endif
	
	for(i=0; i<FIFO_BUFFER_SIZE; i++)
	{
		//ch0
		
		//24bitf[^ -> long̏24bitɊi[ς݁ib31-b8Lf[^Ab7-0=0j
		//longLXgAP2^31Ŋfloat^ɕϊ
		//float:ftHgł4bytex
		
		//y[x] = (long)SSIE0.SSIFRDR.LONG;
		//f[x] = (float)y[x] / 2.147484e9f;
		//x++;
		
		//if(x>=128)
		//{
		//	x=0;
		//	__nop();
		//}
		
		g_pcm0[g_input_index].ch0 = (float)((long)SSIE0.SSIFRDR.LONG) / 2.147484e9f;	//MFIFOf[^ǂݏo

		//ch1
		
#if (USE_CH == 1)
		dummy = SSIE0.SSIFRDR.LONG;	//MFIFOf[^ǂݏoi_~[j
#else
		g_pcm0[g_input_index].ch1 = (float)((long)SSIE0.SSIFRDR.LONG) / 2.147484e9f;	//MFIFOf[^ǂݏo
#endif

		g_input_index++;
		if(g_input_index >= INPUT_BUFFER_SIZE) g_input_index = 0;
	}
	
	SSIE0.SSIFSR.BIT.RDF = 0;		//MFIFO荞݃tONA
}

void Intr_SSIE0_SSIF0(void)
{
	int i;
	
	//ʐMG[ifobKŒ~ꍇ܂ށj
	
	//ʐM~
	SSIE0.SSICR.LONG &= ~0x0003;	//TEN,REN=0 M֎~
	SSIE0.SSIFCR.BIT.TIE = 0;
	SSIE0.SSIFCR.BIT.RIE = 0;
	while(SSIE0.SSISR.BIT.IIRQ != 1)
	{
		__nop();
	}
	
	if(SSIE0.SSISR.BIT.TUIRQ == 1)
	{
		//TXA_[t[NA
		SSIE0.SSISR.BIT.TUIRQ = 0;
	}
	
	if(SSIE0.SSISR.BIT.TOIRQ == 1)
	{
		//TXI[ot[NA
		SSIE0.SSISR.BIT.TOIRQ = 0;
	}
	
	if(SSIE0.SSISR.BIT.RUIRQ == 1)
	{
		//RXA_[t[NA
		SSIE0.SSISR.BIT.RUIRQ = 0;
	}
	
	if(SSIE0.SSISR.BIT.ROIRQ == 1)
	{
		//RXI[o[t[NA
		SSIE0.SSISR.BIT.ROIRQ = 0;
	}
	
	//M
	SSIE0.SSIFCR.BIT.TFRST = 1;		//MFIFOZbg
	SSIE0.SSIFCR.BIT.TFRST = 0;		//Zbg
	while(SSIE0.SSIFCR.BIT.TFRST != 0)	__nop();	//Zbg̊mF
	for(i=0; i< FIFO_BUFFER_SIZE*2; i++)
	{
		SSIE0.SSIFTDR.LONG = 0x0000;	//MFIFOɏf[^i[, MJn㒼ɑMFIFO荞݂1
	}
	SSIE0.SSIFSR.BIT.TDE = 0;		//MFIFO荞݃tONA
	SSIE0.SSIFCR.BIT.TIE = 1;		//Mf[^GveB荞݋
	
	//M
	SSIE0.SSIFCR.BIT.RFRST = 1;		//MFIFOZbg
	SSIE0.SSIFCR.BIT.RFRST = 0;		//Zbg
	while(SSIE0.SSIFCR.BIT.RFRST != 0)	__nop();	//Zbg̊mF
	SSIE0.SSIFSR.BIT.RDF = 0;		//MFIFO荞݃tONA
	SSIE0.SSIFCR.BIT.RIE = 1;		//Mf[^t荞݋

	SSIE0.SSICR.LONG |= 0x0003;	//TEN,REN=1 M
	while(SSIE0.SSISR.BIT.IIRQ != 0)
	{
		__nop();
	}
	
}

 